/*****************************************************************
 GRAPH.C
 Modulo de funcoes graficas, como detectar graph, inicializar
 graph, plotar ptos, plotar retas e  finalizar graph.
*****************************************************************/

/*****************************************************************
 Inclusao de bibliotecas
*****************************************************************/
#include <stdio.h>
#include <conio.h>    // getche
#include <graphics.h> // detect
#include <math.h>

/*****************************************************************
 Variaveis desse modulo
*****************************************************************/
int xmax, ymax, xmin, ymin; // maximo e minimo da tela

/*****************************************************************
 Variaveis externas definidas fora desse modulo
*****************************************************************/
extern int Borda; //tamanho da borda do monitor
extern int CorLinha; //cor da linha
extern int CorFecho; //cor do fecho convexo
extern int npfec;    //numero de pontos do fecho convexo
extern struct ponto {
 int x; //coordenada x
 int y; //coordenada y
} vet[], fec[]; //vet: ptos dados, fec: fecho convexo

/*****************************************************************
 Detecta e inicializa grafico. Se houver erro(2) devolve-o
*****************************************************************/
int InicializaGrafico(void){
 int gdriver = DETECT, gmode, coderro;  // deteccao do driver

 printf("Teste de grafico no borland C\n");
 initgraph(&gdriver, &gmode, "c:/bc/bgi"); //inic. grafico e variaveis
 coderro = graphresult();
 if (coderro != grOk){ // aconteceu um erro
  return 2;
 }
 xmax = getmaxx()-Borda; // o maior valor de x
 ymax = getmaxy()-Borda; // o maior valor de y
 xmin = Borda;           // menor valor de x
 ymin = Borda;           // menor valor de y
 rectangle(xmin-1, ymin-1, xmax+1, ymax+1);
 return 0;
}

/*****************************************************************
 Finaliza o grafico
*****************************************************************/
void FinalizaGrafico(void){
 closegraph();
}

/*****************************************************************
 Testa monitor calculando seus maximos e minimos da tela.
*****************************************************************/
void TestaMonitor(void){
 int telaxmax, telaymax, telaxmin, telaymin; // maximo e minimo da tela
 int x;

 telaxmax = getmaxx(); // o maior valor de x
 telaymin = getmaxy(); // o maior valor de y
 telaxmin = 0;         // menor valor de x
 telaymax = 0;         // menor valor de y

 for(x = telaxmin; x <= telaxmax; x++){ //linhas verticais
  setcolor(x % 16); //cores de 0 a 15
  line(x, telaymax, x, telaymin);
 }
 setcolor(BLUE);
 outtextxy(telaxmax/2, telaymin/2, "OK! Tecle algo para continuar");
 getche();
 cleardevice();

 rectangle(xmin, ymin, xmax, ymax);
 outtextxy(xmin+10, ymin+10, "O retangulo exibe a borda");
 setcolor(CorLinha);
 line(xmin, ymin, xmax, ymax);
 outtextxy(xmin+10, ymin+30, "Cor da linha diagonal");
 setcolor(WHITE);
 outtextxy(telaxmax/2, telaymin/2, "OK! Tecle algo para continuar");
 getche();
}

/*****************************************************************
 Plota o ponto (x,y)
*****************************************************************/
void PlotaPonto(int x, int y){
 putpixel(x + xmin, ymax - y - ymin, WHITE);
}

/*****************************************************************
 Plota a linha do ponto (x1,y1) ate (x2, y2)
*****************************************************************/
void PlotaLinha(int x1, int y1, int x2, int y2, int ap){
 if (ap == 0) setcolor(0);
 else setcolor(CorLinha);
 line(x1 + xmin, ymax - y1 - ymin, x2 + xmin, ymax - y2 - ymin);
 setcolor(15);
}

/*****************************************************************
 Plota o fecho convexo determinado pelo vetor fec. ap determina
 se eh para apagar. np eh o numero de ptos a serem plotados
*****************************************************************/
void PlotaFecho(int ap, int np){
 int i;

 if (ap == 0) setcolor(0);
 else setcolor(CorFecho);
 fec[npfec].x = fec[0].x;
 fec[npfec].y = fec[0].y;
 for(i = 0; i < npfec; i++)
  line(fec[i].x + xmin, ymax - fec[i].y - ymin,
		 fec[i+1].x + xmin, ymax - fec[i+1].y - ymin);
 setcolor(15);
 for(i = 0; i < np; i++) //plota para ficar na cor
  PlotaPonto(vet[i].x, vet[i].y);
}

