/*****************************************************************
 Nome: Elias Yoshiaki Yoshida       No.USP: 0354749
		 Ulisses Kenji Hayashida      No.USP: 0000000
 Prof: Jose Coelho                       22/06/2001
		 MAC 331 - Geometria Computacional
				 compilador: Borland C++ 3.1
*****************************************************************/

/*****************************************************************
 Inclusao de bibliotecas e definicoes de constantes
*****************************************************************/
#define MAX 1024

#include <stdio.h>
#include <conio.h>
#include <time.h>   //randomize
#include <stdlib.h> //igual
#include "tela.h"
#include "graph.h"

/*****************************************************************
 Variaveis globais usados pelo programa
*****************************************************************/
int nptos; //numero de pontos tabelados
int npfec; //numero de pontos do fecho convexo
struct ponto {
 int x; //coordenada x
 int y; //coordenada y
} vet[MAX], fec[MAX]; //vet: ptos dados, fec: fecho convexo
int Borda= 20; //tamanho da borda do monitor
int CorLinha= 2; //cor da linha
int CorFecho= 4; //cor do fecho convexo
int Parada= 1;   //verifica se para a cada iteracao ou nao

/*****************************************************************
 Entrada dos pontos tabelados via arquivo. Se o arquivo nao for
 encontrado retorna o erro 1.
*****************************************************************/
int EntradaPtosTabelados(void) {
 FILE *fp;         //usado para abrir o arquivo
 int dado;         //valor pego no arquivo
 char nomearq[20]; //nome do arquivo dos ptos tabelados
 int i;            //usado no loop


 DesenhaQuadroDup(3, 3);
 printf("Nome do arquivo contendo os pontos tabelados: ");
 scanf ("%s", nomearq);
 fp = fopen (nomearq, "r");
 if (!fp) return 1; //retorna que o arquivo nao foi encontrado

 nptos = 0;
 while (!feof(fp)) {
  fscanf(fp, "%d", &dado);
  vet[nptos].x = dado;
  fscanf(fp, "%d", &dado);
  vet[nptos].y = dado;
  nptos++;
  if (nptos > MAX) break;
 }
 nptos--; //lido final de arquivo como pto vlido. Jogando-o fora
 fclose (fp);

 return 0; //retorna OK
} //fecha EntradaPtosTabelados

/*****************************************************************
 Faz um SWAP entre os pontos dados p1 e p2
*****************************************************************/
void SwapPtos(struct ponto *p1, struct ponto *p2) {
 struct ponto tp;   //usado no swap dos ptos

 tp.x = p1->x; tp.y = p1->y;
 p1->x = p2->x; p1->y = p2->y;
 p2->x = tp.x; p2->y = tp.y;
} //fecha SwapPtos

/*****************************************************************
 Executa o LeftOn. Devolve 1 se o ponto estiver a esquerda, 0
 se estiver encima e -1 se estiver a direita
*****************************************************************/
int LeftOn(struct ponto *p1, struct ponto *p2, struct ponto *p3){
 long res;
 res = (p1->x * p2->y) - (p1->y * p2->x)
	  + (p1->y * p3->x) - (p1->x * p3->y)
	  + (p2->x * p3->y) - (p2->y * p3->x);
 if (res > 0) return 1;
 else if (res == 0) return 0;
 else return -1;
} //fecha LeftOn

/*****************************************************************
 Implementacao do algoritmo incremental
*****************************************************************/
void AlgoritmoIncremental(void) {
 int i, j;
 int vtIni, vtFim; //vertices de tangencia inicial e final

 if (nptos < 3) {
  ExibeErro(6, 10, 21);
  getch();
 }
 else {
  if (LeftOn(&vet[0], &vet[1], &vet[2]) >= 0)
	for(i = 0; i < 3; i++){ //eh o triangulo do fecho
	 fec[i].x= vet[i].x; fec[i].y= vet[i].y;
	}
  else{
	fec[0].x= vet[0].x; fec[0].y= vet[0].y;
	fec[1].x= vet[2].x; fec[1].y= vet[2].y;
	fec[2].x= vet[1].x; fec[2].y= vet[1].y;
  }
  npfec = 3;
  for(i = 3; i < nptos; i++) {
	vtIni = -1; //inicializa c/negativo
	vtFim = 0;
	for(j = 0; j < npfec; j++) {
	 PlotaLinha(fec[j].x, fec[j].y, vet[i].x, vet[i].y, 1);
	 PlotaLinha(fec[j+1].x, fec[j+1].y, vet[i].x, vet[i].y, 1);
	 PlotaPonto(vet[i].x, vet[i].y);
	 PlotaFecho(1, i);
	 if(Parada) getch();
	 if (LeftOn(&fec[j], &fec[j+1], &vet[i]) < 0) {
	  if (vtIni < 0) vtIni = j;
	  else if ((vtIni > 0)&&(vtFim == 0)) vtFim = j; //nao passa pelo zero
	  else {
		if (vtFim == j-1) vtFim = j;
		else if (vtIni != j-1) vtIni = j;
	  }
	 }
	 PlotaLinha(fec[j].x, fec[j].y, vet[i].x, vet[i].y, 0);
	 PlotaLinha(fec[j+1].x, fec[j+1].y, vet[i].x, vet[i].y, 0);
	 PlotaFecho(0, i);
	} //fecha for j
	if (vtIni < 0){ //eh a esquerda de tudo, nao faz parte do fecho
	 //nada a acrescentar
	} else if (vtFim == 0){ //so tem uma aresta direita
	 j = npfec;
	 while(j > (vtIni + 1)){
	  fec[j].x = fec[j-1].x; fec[j].y= fec[j-1].y;
	  j--;
	 }
	 fec[j].x = vet[i].x; fec[j].y = vet[i].y;
	 npfec++;
	}else{ //tem ini e fim
	 if (vtIni <= vtFim){
	  fec[vtIni+1].x = vet[i].x; fec[vtIni+1].y = vet[i].y;
	  for (j = vtIni+2; j <= (npfec - vtFim + vtIni); j++) {
		fec[j].x = fec[vtFim-vtIni-1+j].x;
		fec[j].y = fec[vtFim-vtIni-1+j].y;
	  }
	  npfec = npfec - (vtFim - vtIni) + 1;
	 }else{ //ini e fim trocado
	  npfec = 1;
	  fec[0].x = vet[i].x; fec[0].y = vet[i].y;
	  j = vtFim+1;
	  while (j <= vtIni){
		fec[npfec].x = fec[j].x;
		fec[npfec].y = fec[j].y;
		j++;
		npfec++;
	  }
	 } //fecha if ini e fim trocado
	} //tem ini e fim
  } //fecha for i

  PlotaFecho(1, nptos);
  getch();
 } //fecha else
} //fecha AlgoritmoIncremental

/*****************************************************************
 PROGRAMA PRINCIPAL
*****************************************************************/
int main(void) {
 int op;       //armazena opcao digitada
 int codErro;  //eh o codigo do erro
 int i, j;     //usado em loops

 randomize();
 TelaApresentacao();
 npfec= 0;
 do{
  TelaDeOpcoes();
  op = getche();
  gotoxy(3, 21);
  switch(op){

	case '8':
	 vet[0].x=100; vet[0].y=10;
	 vet[1].x=250; vet[1].y=250;
	 vet[2].x=50; vet[2].y=120;
//	 vet[0].x=0; vet[0].y=0;
  //	 vet[1].x=10; vet[1].y=0;
	 //vet[2].x=15; vet[2].y=-1;

	 if (LeftOn(&vet[0],&vet[1], &vet[2]) < 0) printf("Bosta");
	 else printf("OK");

    getch();
	break;

	case '1': //leitura dos pontos de um arquivo
	 codErro = EntradaPtosTabelados();
	 if (codErro == 1) ExibeErro(codErro, 3, 5);
	 else{
	  gotoxy(3, 5);
	  //Exibe x e y lidos do arquivo.
	  printf("Exibe coordenadas dos pontos lidos do arquivo");
	  for (i = 0; i < nptos; i++){
		gotoxy(3, 6 + (i%15));
		printf("[%04d]- %03d\t\t%03d", i, vet[i].x, vet[i].y);
	  }
	  gotoxy(3, 22);
	  printf ("N. Pontos: %d", nptos);
	 }
	 getch();
	break;

	case '2': //entrada manual dos pontos
	 DesenhaQuadroDup(3, 3);
	 printf("Digite as coordenadas x e y do ponto.");
	 printf(" Para finalizar digite 0 0.");
	 i = -1;
	 do {
	  i++;
	  gotoxy(3, 5 + (i%15));
	  printf("ponto %d: ", i);
	  scanf("%d %d", &vet[i].x, &vet[i].y);
	 }while ((vet[i].x != 0) || (vet[i].y != 0));
	  nptos = i;
	  gotoxy(3, 22);
	  printf ("N. Pontos: %d", nptos);
	  getch();
	break;

	case '3': //altera ordem dos pontos dados
	 TelaDeAlteraPtos();
	 op = getche();
	 codErro= 0;
	 switch(op){
	  case '1': //inverte pontos
		for(i = 0; i < (nptos /2); i++)
		 SwapPtos(&vet[i], &vet[nptos -i -1]);
	  break;
	  case '2': //ordem crescente por x
	  case '3': //ordem decrescente por x
		for(i = 0; i < (nptos-1); i++)
		 for(j = i+1; j < nptos; j++)
		  if(vet[i].x > vet[j].x) SwapPtos(&vet[i], &vet[j]);
		  else if(vet[i].x == vet[j].x) {
			if(vet[i].y > vet[j].y) SwapPtos(&vet[i], &vet[j]);
		  }
		if(op =='3') //inverte
		 for(i = 0; i < (nptos /2); i++)
		  SwapPtos(&vet[i], &vet[nptos -i -1]);
	  break;
	  case '4': //ordem crescente por y
	  case '5': //ordem decrescente por y
		for(i = 0; i < (nptos-1); i++)
		 for(j = i+1; j < nptos; j++)
		  if(vet[i].y > vet[j].y) SwapPtos(&vet[i], &vet[j]);
		  else if(vet[i].y == vet[j].y) {
			if(vet[i].x > vet[j].x) SwapPtos(&vet[i], &vet[j]);
		  }
		if(op =='5') //inverte
		 for(i = 0; i < (nptos /2); i++)
		  SwapPtos(&vet[i], &vet[nptos -i -1]);
	  break;
	  case '6': //ordem aleatoria
		for(i = 0; i < nptos; i++) {
		 j = (rand() % nptos);
		 SwapPtos(&vet[i], &vet[j]);
		}
	  break;
	  default: //opcao inexistente
		codErro = 4;
		ExibeErro(codErro, 3, 21); //opcao invalida e retorna p/menu principal
		op = '9';
	  break;
	 } //fecha switch do caso 3
	 if (codErro != 4){ //se nao deu errado
	  gotoxy(3, 21);
	  printf("OK! Tecle algo para retornar.");
	 }
	 getch();
	break;

	case '4': //resolve o problema
	 codErro = InicializaGrafico();
	 if (codErro != 0) ExibeErro(codErro, 3, 5);
	 else{
	  AlgoritmoIncremental();

	 }
	 FinalizaGrafico();

	break;

	case '9': //testa monitor
	 TelaDeSETUP();
	 op = getche();
	 gotoxy(3, 21);
	 switch(op){
	  case '1': //altera borda do monitor
		printf("Novo valor da borda: "); scanf("%d", &Borda);
		if ((Borda > 50) || (Borda < 1)){
		 ExibeErro(3, 3, 22); //intervalo invalido e retorna
		 Borda = 20;
		 getch();
		}
	  break;
	  case '2': //altera cor da linha
		printf("Nova Cor da linha: "); scanf("%d", &CorLinha);
		if ((CorLinha > 14) || (CorLinha < 1)){
		 ExibeErro(5, 3, 22); //intervalo invalido e retorna
		 CorLinha = 2;
		 getch();
		}
	  break;
	  case '3': //altera cor do fecho convexo
		printf("Nova Cor do fecho: "); scanf("%d", &CorFecho);
		if ((CorFecho > 14) || (CorFecho < 1)){
		 ExibeErro(5, 3, 22); //intervalo invalido e retorna
		 CorFecho = 4;
		 getch();
		}
	  break;
	  case '4': //altera se para ou nao
		if (Parada) {
		 printf("Alterado para nao ocorrer parada intermediaria!");
		 Parada = 0;
		} else {
		 printf("Alterado para ocorrer paradas!");
		 Parada = 1;
		}
		getch();
	  break;
	  case '5': //testa monitor
		InicializaGrafico();
		TestaMonitor();
		FinalizaGrafico();
	  break;
	  default: //opcao inexistente
		codErro = 4;
		ExibeErro(codErro, 3, 21); //opcao invalida e retorna p/menu principal
		op = '9';
	  break;
	 } //fecha switch do caso 9
	break;

	case '0': break; //sai do programa

	default: //opcao inexistene
	 ExibeErro(7, 3, 21); //opcao invalida
	 getch();
	break;
  } //fecha switch
 }while(op != '0');


 return 0;
}