/*****************************************************************
 TELA.C
 Modulo de funcoes de exibicao na tela.
*****************************************************************/
#include <stdio.h>
#include <conio.h>

/*****************************************************************
 Variaveis externas definidas fora desse modulo
*****************************************************************/
extern int Borda; //tamanho da borda do monitor
extern int CorLinha; //cor da linha
extern int CorFecho; //cor do fecho convexo
extern int Parada;   //verifica se para a cada iteracao ou nao

/*****************************************************************
 Exibe as linhas que formam o quadro e posiciona o cursor em x,y.
*****************************************************************/
void DesenhaQuadroDup(int x, int y){
 int i;

 clrscr();
 // parte superior
 putchar(201);
 for (i = 0; i < 78; i++)
  putchar(205);
 putchar(187);
 // tracos verticais direito e esquerdo
 for (i = 2; i < 24; i++){
  gotoxy(1 , i);
  putchar(186);
  gotoxy(80, i);
  putchar(186);
 }
 // parte inferior
 gotoxy(1, 24);
 putchar(200);
 for (i = 0; i<78; i++)
  putchar(205);
 putchar(188);
 gotoxy(x,y);
} // fecha DesenhaQuadroDup

/*****************************************************************
 Exibe a tela de apresentacao.
*****************************************************************/
void TelaApresentacao(void){
 DesenhaQuadroDup(3,3); printf("UNIVERSIDADE DE SAO PAULO");
 gotoxy(3, 4); printf("Instituto de Matematica e Estatistica");
 gotoxy(3, 6); printf("Disciplina: MAC-331 Geometria Computacional");
 gotoxy(3, 7); printf("Prof.     : Jose Coelho");
 gotoxy(3, 8); printf("Alunos    : Elias Yoshiaki Yoshida ");
 printf("   n.USP:0354749");
 gotoxy(3, 9); printf("            Ulisses Kenji Hayashida");
 printf("   n.USP:2941629");
 gotoxy(3,11); printf("Projeto de Geometria Computacional");
 gotoxy(3,13); printf("Fecho Convexo - Algoritmo Incremental");
 gotoxy(23,19);printf("Digite algo para continuar");
 getche();
} // fecha TelaApresentacao

/*****************************************************************
 Exibe uma tela de opcoes.
*****************************************************************/
void TelaDeOpcoes(void){
 DesenhaQuadroDup(15, 3);
 printf("Menu principal");
 gotoxy(3, 5); printf("<1> Ler os pontos de um arquivo");
 gotoxy(3, 7); printf("<2> Digitar pontos manualmente");
 gotoxy(3, 9); printf("<3> Alterar ordem dos pontos");
 gotoxy(3,11); printf("<4> Resolver usando o Algoritmo Incremental");
 gotoxy(3,15); printf("<9> SETUP");
 gotoxy(3,17); printf("<0> Sair do programa");
 gotoxy(3,19); printf("Digite a sua opcao: ");
} // fecha TelaDeOpcoes

/*****************************************************************
 Exibe tela de alteracao de pontos
*****************************************************************/
void TelaDeAlteraPtos(void){
 DesenhaQuadroDup(15, 3);
 printf("Alteracao dos Pontos:");
 gotoxy(3, 5); printf("<1> Inverter o vetor de pontos");
 gotoxy(3, 7); printf("<2> Colocar em ordem crescente por x");
 gotoxy(3, 9); printf("<3> Colocar em ordem decrescente por x");
 gotoxy(3,11); printf("<4> Colocar em ordem crescente por y");
 gotoxy(3,13); printf("<5> Colocar em ordem decrescente por y");
 gotoxy(3,15); printf("<6> Alterar aleatoriamente os pontos");
 gotoxy(3,19); printf("Digite a sua opcao: ");
} // fecha TelaDeAlteraPtos

/*****************************************************************
 Exibe a tela de SETUP
*****************************************************************/
void TelaDeSETUP(void){
 DesenhaQuadroDup(15, 3);
 printf("SETUP");
 gotoxy(3, 5); printf("<1> Borda do monitor: %d", Borda);
 gotoxy(3, 7); printf("<2> Cor da linha: %d", CorLinha);
 gotoxy(3, 9); printf("<3> Cor do fecho: %d", CorFecho);
 gotoxy(3,11); printf("<4> Parada Intermediaria: ");
 if (Parada) printf("SIM"); else printf("NAO");
 gotoxy(3,13); printf("<5> Testar Monitor");
 gotoxy(3,19); printf("Digite a sua opcao: ");
} // fecha TelaDeSETUP

/*****************************************************************
 Exibe uma mensagem de erro de acordo erro na posicao (x,y).
*****************************************************************/
void ExibeErro(int erro, int x, int y){
 gotoxy(x, y);
 if (erro == 1) printf("Arquivo de entrada nao encontrado!!!  ");
 else if (erro == 2)
  printf("Erro na inicializacao grafico. Vide arquivo GRAPH.C ");
 else if (erro == 3)
  printf("Borda deve estar entre 1 e 50. Retornando ao menu principal.");
 else if (erro == 4)
  printf("Opcao invalida, retornando ao menu principal!!!");
 else if (erro == 5)
  printf("Intervalo de Cor entre 1 e 14. Retornando ao menu principal.");
 else if (erro == 6)
  printf("Deve haver pelo menos tres pontos para calcular fecho convexo.");
 else if (erro == 7)
  printf("Opcao inexistente!!!");
 else printf("Erro nao determinado!!!");
} // fecha ExibeErro